<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

var poolsAreValid = false;
var poolDateIsValid = false;
var pools;

function init()
{
	var frm = document.forms['reggie'];
	pools = getUnpooledPools();
	
	var poolsList = frm.pools;
	var plateList = frm.bioplate;
	
	// We get a list of pools from the servlet
	// Each pool has a list of libraries 
	// We want to find the Library bioplates that are unique
	// within a pool (eg. all libraries are from the same bioplate)
	if (pools != null && pools.length > 0)
	{
		var libPlates = [];
		for (var poolNo=0; poolNo < pools.length; poolNo++)
		{
			var pool = pools[poolNo];
			
			var libPlateForPool = null;
			for (var libNo = 0; libNo < pool.libraries.length; libNo++)
			{
				var lib = pool.libraries[libNo];
				var libPlate = lib.bioWell.bioPlate;
				
				if (libNo == 0)
				{
					libPlateForPool = libPlate;
				}
				else if (libPlateForPool.id != libPlate.id)
				{
					libPlateForPool = null;
					break;
				}
			}
			
			// Store the library bioplate
			pool.libPlate = libPlateForPool;
			
			// If the pool has a single library bioplate add it to the selection list
			// If the pool doesn't have a single library bioplate, nothing is added to
			// the list and the pool can only be selected when the 'multiple' option is
			// active for the bioplates list
			if (libPlateForPool != null && !libPlates[libPlateForPool.name])
			{
				libPlates[libPlateForPool.name] = libPlateForPool;
				var plateOption = new Option(libPlateForPool.name, libPlateForPool.id);
				plateOption.plate = libPlateForPool;
				plateList[plateList.length] = plateOption;
			}

		}
		if (plateList.length > 1) plateList.selectedIndex = 1;
		bioplateOnChange();
		Main.show('step.1.section');
		Main.show('gocreate');
		Main.show('navigation');
	}
	else
	{
		var msg = 'No pools available for processing.';
		setFatalError(msg);
		return;
	}

}


function getUnpooledPools()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading pools...');
		var url = '../Pool.servlet?ID=<%=ID%>&cmd=GetUnprocessedPools';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.pools;
}

// Add pools to the pools list based on the bioplate selection
function bioplateOnChange()
{
	var frm = document.forms['reggie'];
	
	var libPlateId = parseInt(frm.bioplate.value);

	// Clear current list
	frm.pools.length = 0;
	
	for (var poolNo = 0; poolNo < pools.length; poolNo++)
	{
		var pool = pools[poolNo];
		// If a libplate is selected, only show pools that have all libraries from that plate
		// If no libplate is selected, only show pools that have libraries from multiple plates
		var addPool = (libPlateId && pool.libPlate.id == libPlateId) || (!libPlateId && pool.libPlate == null);
		if (addPool)
		{
			frm.pools[frm.pools.length] = new Option(pool.name, pool.id, libPlateId);
		}
	}
	
	setInputStatus('pools', '', '');
	if (libPlateId)
	{
		frm.pools.disabled = true;
	}
	else
	{
		frm.pools.disabled = false;
	}
	poolOnBlur();
}

function poolOnBlur()
{
	var frm = document.forms['reggie'];
	
	poolsAreValid = false;
	setInputStatus('pools', '', '');

	for (var i = 0; i < frm.pools.length; i++)
	{
		if (frm.pools[i].selected)
		{
			poolsAreValid = true;
		}
	}
	
	if (!poolsAreValid)
	{
		setInputStatus('pools', 'Select at least one pool', 'invalid');
		return;
	}
	
	setInputStatus('pools', '', 'valid');
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	setCurrentStep(currentStep);
}

function gotoStep2()
{
	if (!poolsAreValid) return;
	
	var frm = document.forms['reggie'];	
	frm.bioplate.disabled = true;
	frm.pools.disabled = true;
	
	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.hide('gonext');
	Main.show('gocancel');
	Main.show('goregister');
	
	// Load pooling protocols
	var poolProtocols = getProtocols('POOLING_PROTOCOL');
	for (var i = 0; i < poolProtocols.length; i++)
	{
		var protocol = poolProtocols[i];
		frm.poolProtocol[frm.poolProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('poolProtocol', '', 'valid');
	}
	if (frm.poolProtocol.length == 0)
	{
		frm.poolProtocol[0] = new Option('- none -', '');
	}

	frm.poolDate.focus();
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function poolDateOnChange()
{
	var frm = document.forms['reggie'];
	poolDateIsValid = false;
	setInputStatus('poolDate', '', '');
	
	var poolDate = frm.poolDate.value;
	
	if (poolDate == '')
	{
		setInputStatus('poolDate', 'Missing', 'invalid');
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	poolDate = autoFillDate(poolDate);
	frm.poolDate.value = poolDate;
	
	if (!Dates.isDate(poolDate, 'yyyyMMdd'))
	{
		setInputStatus('poolDate', 'Not a valid date', 'invalid');
		return;
	}
	
	setInputStatus('poolDate', '', 'valid');
	poolDateIsValid = true;
}

function goRegister()
{
	if (!poolDateIsValid) return;
	
	var frm = document.forms['reggie'];
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.addClass(document.getElementById('step.2.section'), 'disabled');

	frm.poolOperator.disabled = true;
	frm.poolProtocol.disabled = true;
	frm.poolDate.disabled = true;
	frm.comments.disabled = true;
	
	var pools = [];
	for (var i = 0; i < frm.pools.length; i++)
	{
		if (frm.pools[i].selected) pools[pools.length] = parseInt(frm.pools[i].value, 10);
	}
	var submitInfo = {};
	submitInfo.pools = pools;
	submitInfo.poolDate = frm.poolDate.value;
	submitInfo.poolProtocol = parseInt(frm.poolProtocol.value, 10);
	submitInfo.poolOperator = frm.poolOperator.value;
	submitInfo.comments = frm.comments.value;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../Pool.servlet?ID=<%=ID%>&cmd=RegisterPooledLibraries';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	

	
}
</script>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register pooled libraries" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="pool_protocol2.jsp" method="post" target="_blank">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="view" value="list">
	
	<div id="step.1.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select pools</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Library plate</td>
				<td class="input">
					<select style="width:90%;" name="bioplate" id="bioplate" onchange="bioplateOnChange()">
						<option value="0">- multiple -
					</select>
					<br>
					<i>- or -</i>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select the library bioplate that should be pooled in this step. The list contains
					all plates with pools that has not yet been created (determined by abscense of creation date).
					Use the <b>multiple</b> option to select pools with libraries from multiple plates.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Pools</td>
				<td class="input"><select style="width:90%;" size="6" 
						name="pools" id="pools" multiple></select>
				</td>
				<td class="status" id="pools.status"></td>
				<td class="help"><span id="pools.message" class="message" style="display: none;"></span>
					Select the pools to work with. If a plate has been selected no changes can be made.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle">Pooling results</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" class="required" name="poolDate" value="" size="12" maxlength="10"
						onblur="poolDateOnChange()" onkeypress="focusOnEnter(event, 'poolProtocol')">
				</td>
				<td class="status" id="poolDate.status"></td>
				<td class="help">
					<span id="poolDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input"><select style="width:90%" name="poolProtocol" id="poolProtocol" 
					onkeypress="focusOnEnter(event, 'poolOperator')"></select></td>
				<td class="status" id="poolProtocol.status"></td>
				<td class="help"><span id="poolProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used when pooling.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="poolOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 90%;" maxlength="255" onkeypress="focusOnEnter(event, 'comments')">
				</td>
				<td class="status" id="poolOperator.status"></td>
				<td class="help">
					<span id="poolOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea rows="4" cols="50" style="width: 90%;" name="comments" value=""></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help"><span id="comments.message" class="message" style="display: none;"></span>Comments about the pooling.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px; display: none;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>