<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

function init()
{
	var frm = document.forms['reggie'];
	var bioplates = getMRnaBioPlates();
	
	var plates = frm.bioplate;
	if (bioplates != null && bioplates.length > 0)
	{
		for (var i=0; i < bioplates.length; i++)
		{
			var bioplate = bioplates[i];
			var option = new Option(bioplate.name, bioplate.id);
			option.bioplate = bioplate;
			plates.options[plates.length] = option;
		}
		bioplateIsValid = true;
		Main.show('gocreate');
		bioPlateOnChange();
		loadStratageneConc();
	}
	else
	{
		var msg = 'No mRNA bioplates available for processing.';
		setFatalError(msg);
	}
}

function getMRnaBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading histology work lists...');
		var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetUnprocessedPlates&plateType=MRNA';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.bioplates;
}

function viewProtocol(type)
{
	saveStratageneConc();
	
	var frm = document.forms['reggie'];
	if (frm.bioplate && !frm.bioplate.disabled)
	{
		frm.view.value = type;
		frm.submit();
	}
}

function goExport(exporter)
{
	var frm = document.forms['reggie'];	
	if (frm.bioplate && !frm.bioplate.disabled)
	{
		alert('Not implemented');
	}
}

function bioPlateOnChange()
{
	var frm = document.forms['reggie'];
	var bioplate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
	setInnerHTML('comments', formatText(bioplate.comments));
	frm.poolSchema.value = bioplate.poolSchema;
}

function saveStratageneConc()
{
	if (!window.localStorage) return;
	
	var frm = document.forms['reggie'];	
	var stratageneInfo = new Object();
	stratageneInfo.conc = frm.stratageneConc.value;
	window.localStorage.setItem('reggie.stratagene-info', JSON.stringify(stratageneInfo));
}

function loadStratageneConc()
{
	if (!window.localStorage) return;
	var frm = document.forms['reggie'];	
	
	var stratageneInfo = JSON.parse(window.localStorage.getItem('reggie.stratagene-info'));
	if (stratageneInfo)
	{
		frm.stratageneConc.value = stratageneInfo.conc;
	}
}
</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab protocols for mRNA and cDNA preparation" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="mrna_protocol2.jsp" method="post" target="_blank">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="view" value="list">
	<input type="hidden" name="poolSchema" value="5by24">
	
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select mRNA bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">mRNA bioplate</td>
				<td class="input"><select style="width:90%" 
						name="bioplate" id="bioplate" onchange="bioPlateOnChange()"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help" rowspan="2"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select an existing mRNA bioplate. The list contain all mRNA bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">-comments</td>
				<td class="input" id="comments" style="font-style: italic; background: #E8E8E8; padding: 2px 5px 2px 5px;"></td>
				<td class="status" id="comments.status"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Stratagene conc.</td>
				<td class="input">
					<input type="text" name="stratageneConc" 
						style="width: 10em;" maxlength="8"
						onkeypress="return Numbers.numberOnly(event)"
					> (ng/µl)
				</td>
				<td class="status" id="stratagene.status"></td>
				<td class="help"><span id="stratagene.message" class="message" style="display: none;"></span>
					If the current Stratagene concentration is given, the wizard will calculate volumes
					to use automatically.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Lab protocols</td>
				<td class="input" id="protocol" style="white-space: nowrap; line-height: 1.5em;">
					<span class="link" onclick="viewProtocol('list')"><img src="../images/listview.png">&nbsp;List layout</span><br>
					<span class="link" onclick="viewProtocol('plate')"><img src="../images/plateview.png">&nbsp;Plate layout</span><br>
				</td>
				<td class="status" id="protocol.status"></td>
				<td class="help"><span id="protocol.message" class="message" style="display: none;"></span>
					The 'list layout' generates a table with one row for each well on the work plate.
					The 'plate layout' generates a grid with wells arranged according to row and column coordinates.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>